# abar.py
# obj: manage a single Bar
#===========================
import sys
import importlib.resources as pr

class Bar:
    def loadDico():
        lignes = pr.open_text( __package__ + '.data', 'bars.dic').readlines()
        idBars = {}
        for ligne in lignes:
            if ligne[0] == "#": continue
            ligne = ligne.rstrip()
            theType, ident = ligne.split()
            #print(theType, ident)
            idBars[ ident ] = theType
        #print( idBars )
        return idBars

    idBars = loadDico()

    def __init__(self, num, ident, lugs):
        self.num   = num
        self.ident = ident
        self.theType = []
        theType = self.idBars[ ident ]
        for lettre in theType:
            self.theType.append( lettre )
        self.lugs = []
        for char in lugs:
            self.lugs.append( int(char) )
        #if self.DEBUG:
        #    print(self.ident, self.theType, self.lugs )

    def information(self):
        info = {}
        info["num"] = self.num
        info["ident"] = self.ident
        info["type"] = self.theType
        info["lugs"] = self.lugs
        return info

    def isShifted(self, guides ):
        for i in range(6):
            if guides[i] and self.lugs[i]:
                return True
        return False

    def getTheType(self):
        return self.theType[0]

    def advanceOfWheels(self, guides ):
        advances = [0]*6
        barmoved = self.isShifted( guides )
        for i in range(6):
            if self.theType[i+1] == 'O':
                continue
            if self.theType[i+1] == 'A':
                if barmoved : advances[i] = 1
            if self.theType[i+1] == 'B':
                if not barmoved : advances[i] = 1
            if self.theType[i+1] == 'C':
                advances[i] = 1
        return advances

if __name__ == "__main__":
    print("====> test 'abar.py'")
    b1 = Bar( 1, "14", "101010" )
    guides = [0,0,1,1,1,1] 
    print( b1.information() )
    print( b1.isShifted( guides ) )
    print( b1.advanceOfWheels( guides ) )

    b1 = Bar( 2, "14", "101010" )
    guides = [0,1,0,1,0,1] 
    print( b1.isShifted( guides ) )
    print( b1.advanceOfWheels( guides ) )

    b1 = Bar( 3, "15", "101010" )
    guides = [0,0,1,1,1,1] 
    print( b1.isShifted( guides ) )
    print( b1.advanceOfWheels( guides ) )

    b1 = Bar( 4, "14", "101010" )
    guides = [0,0,0,0,0,0] 
    print( b1.isShifted( guides ) )
    print( b1.advanceOfWheels( guides ) )

