# setofwheel.py
# make a set of wheels
# need of models of wheels and
# configuration of pins of a set of wheels
# for each wheel, we have an unique name
import cxlibs.awheel

def makeSetOfWheel( machine, nameOfConfig ):
    setOfWheel = {}
    fic = open( machine + "/" + nameOfConfig + ".wheels", "r" )
    lines = fic.readlines()
    #print(lines)
    for line in lines:
        if line[0] == "#": continue
        name, theType, pins = (line.rstrip()).split(":")
        setOfWheel[ name ] = cxlibs.awheel.Wheel( theType, pins )
    return setOfWheel

if __name__ == "__main__":
    print("=====> test 'setofwheel.py'")
    setOfWheel = makeSetOfWheel( "DE", "dragon" )
    print(setOfWheel["a29"].getExternalKey())

